io.stdout:setvbuf("no")

local PROJECT_TITLE = "Robot Companions - Love2D Jam";

local PROJECT_IDENTITY = "base_system_folder";

local PROJECT_VERSION = "1.0.0";

local LOVE_VERSION = "0.10.2";

---
-- Initialise löve's config file.
-- @param t
--
function love.conf(t)
    t.identity = PROJECT_IDENTITY;
    t.version = LOVE_VERSION;

    t.accelerometerjoystick = true;
    t.gammacorrect = false;

    t.window.title = PROJECT_TITLE .. ' - v' .. PROJECT_VERSION;
    t.window.icon = nil;
    t.window.width = 1920;
    t.window.height = 1080;
    t.window.borderless = false;
    t.window.resizable = false;
    t.window.fullscreen = true;
    t.window.fullscreentype = "desktop";
    t.window.vsync = true;
    t.window.msaa = 0;
    t.window.display = 1;
    t.window.highdpi = false;
    t.window.x = nil;
    t.window.y = nil;

    t.modules.audio = true;
    t.modules.event = true;
    t.modules.graphics = true;
    t.modules.image = true;
    t.modules.joystick = false;
    t.modules.keyboard = true;
    t.modules.math = true;
    t.modules.mouse = true;
    t.modules.physics = false;
    t.modules.sound = true;
    t.modules.system = true;
    t.modules.timer = true;
    t.modules.touch = false;
    t.modules.video = true;
    t.modules.window = true;
    t.modules.thread = true;
end

---
-- Returns the project's version.
--
function getVersion()
    if PROJECT_VERSION then
        return PROJECT_VERSION;
    end
end

---
-- Returns the project's title.
--
function getTitle()
    if PROJECT_TITLE then
        return PROJECT_TITLE;
    end
end