local ResourceLoader = require 'lib.resourceLoader'

-- ------------------------------------------------
-- Crusher Class
-- ------------------------------------------------
local Crusher = {}

-- ------------------------------------------------
-- Resource Loading
-- ------------------------------------------------

local images = {}

-- Register module with resource manager.
ResourceLoader:register(Crusher);

---
-- Load images.
--
function Crusher.loadImages()
    images['crusher_open'] = ResourceLoader:loadImage('res/crusher/companionbots_destructo_01.png')
    images['crusher_closing'] = ResourceLoader:loadImage('res/crusher/companionbots_destructo_02.png')
    images['crusher_closed'] = ResourceLoader:loadImage('res/crusher/companionbots_destructo_03.png')
    images['crusher_half'] = ResourceLoader:loadImage('res/crusher/companionbots_destructo_04.png')
end

function Crusher:new()
    local self = {}
    local open = false
    local closing = false
    local count = 0

    function self:action()
        open = not open
    end

    function self:draw(x, y)
        if open then
            love.graphics.draw(images['crusher_open'], x, y)
            closing = true
        elseif closing then
            love.graphics.draw(images['crusher_closing'], x, y)
            if count == 5 then
                closing = false
                count = 0
            else
                count = count + 1
            end
        else
            love.graphics.draw(images['crusher_closed'], x, y)
        end
    end

    return self;
end

return Crusher