local Robot = require 'src.entities.robot'

-- ------------------------------------------------
-- RobotManager Class
-- ------------------------------------------------
local RobotManager = {}

function RobotManager:new(limit)
    local self = {}
    local robots = {}
    local limit = limit

    local function scareRemainingRobots()
      for index=1, #robots do
            robots[index]:scare()
            -- print (robots[index]:specs())
      end
    end

    function self:assemble(num)
        for var = 1, num, 1 do
            local bot = Robot:new()
            bot:init()
            self:enqueue(bot)
        end
    end

    function self:enqueue(robot)
        if self:countBots() == limit then
            local deadBot = self:destroyFirstRobot()
            -- scareRemainingRobots()
        end
        table.insert(robots, 1, robot)
    end

    function self:destroyFirstRobot()
        return table.remove(robots)
    end

    function self:removeRobot(index)
        local bot = robots[index]
        -- replace with nil to keep the position in the array
        robots[index] = nil
        return bot
    end

    -- return front robot
    function self:front()
        return robots[#robots];
    end

    -- return front robot
    function self:getRobots()
        return robots;
    end

    function self:countBots()
        return #robots;
    end

    return self;
end

return RobotManager