local ScreenManager = require 'lib.screenmanager.ScreenManager'
local Screen = require 'lib.screenmanager.Screen'
local Splash = require 'lib.o-ten-one'
local ResourceLoader = require 'lib.resourceLoader'

local Intro = {}

function Intro.new()
    local self = Screen.new()
    local splash = Splash()
    local showSplash = true
    local counter = 0;
    local loading = false;

    function self:init()
        showSplash = true
    end

    function self:draw()
        if showSplash then
            splash:draw()
        end
    end

    function self:update(dt)

        counter = counter + 1;

        if counter > 20 and not loading then
            ResourceLoader:loadResources();
            loading = true;
        end
        if showSplash then
            splash:update( dt )

            if splash.done then
                if ResourceLoader:isDone() then
                    showSplash = not showSplash
                    -- ScreenManager.push( 'menu' )
                    ScreenManager.push( 'game' )
                end
            end
        end
    end

    return self
end

return Intro